program vigener;

{$ifdef windows}
uses wincrt;
{$d Vigenere/rot13-coder}
{$r lock.res}
{$endif}

var
 ch:string;
 s:string;
 j,k:byte;
 i:byte;
 error:integer;
const
 invert:boolean=false;
 hex: boolean=false;
 ieol:boolean=false;
 mode:byte=0;

procedure help;
begin
  writeln('vigener -options chiffre'#10);
  writeln('Options:');
  writeln('  c: crypt');
  writeln('  d: decrypt');
  writeln('  i: invert');
  writeln('  h: chiffre is in hex');
  writeln('  l: ignore end of line');
  writeln('  r: rot n');
{$ifndef windows}
  writeln;
  writeln('if you type at the console, press control-z to exit');
{$endif}
  halt(126);
end;

begin
  if (paramcount<>2) then help;
  s:=paramstr(1);
  if s[1]<>'-' then help;
  for i:=2 to length(s) do case s[i] of
    'c':mode:=1;
    'd':mode:=2;
    'x':mode:=5;
    'i':begin invert:=true;if mode=0 then mode:=3; end;
    'h':hex:=true;
    'l':ieol:=true;
    'r':mode:=4;
  else
    help;
  end;
  if mode=0 then help;
  if mode=4 then begin
    s:=paramstr(2);
    val(s,k,error);
    if error<>0 then help;
    while not eof do begin
      read(char(j));
      if (j>=byte('A')) and (j<=byte('Z')) then begin
	j:=j+k;
	if j>byte('Z') then j:=j-26;
      end else if (j>=byte('a')) and (j<=byte('z')) then begin
	j:=j+k;
	if j>byte('z') then j:=j-26;
      end;
      write(char(j));
    end;
  end else if hex then begin
    s:=paramstr(2);
    if odd(length(s)) then help;
    for i:=1 to length(s) div 2 do begin
      j:=byte(s[i*2-1])-byte('0');
      if (j>=9) then begin
	if j>byte('Z')-byte('0')
	then j:=j-$20;
	j:=j-byte('A')+byte('0')+10;
	if j>15 then help;
      end;
      k:=j shl 4;
      j:=byte(s[i*2])-byte('0');
      if (j>=9) then begin
	if j>byte('Z')-byte('0')
	then j:=j-$20;
	j:=j-byte('A')+byte('0')+10;
	if j>15 then help;
      end;
      ch[i]:=char(k or j);
    end;
    ch[0]:=char(i);
  end else begin
    ch:=paramstr(2);
  end;
  if mode=2 then begin
    for i:=1 to length(ch) do byte(ch[i]):=-byte(ch[i]);
  end else if mode=3 then ch:=#0;
  i:=1;
  k:=length(ch);
  while not eof do begin
    read(char(j));
    if not(ieol and (j=10)or(j=13)) then begin
      if invert then j:=-j;
      j:=j+byte(ch[i]);
      inc(i);if i>k then i:=1;
    end;
    write(char(j));
  end;
end.
